
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Plantseg &#8212; seg_compare 0.0.1 documentation</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">seg_compare 0.0.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Plantseg</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="tex2jax_ignore mathjax_ignore section" id="plantseg">
<h1>Plantseg<a class="headerlink" href="#plantseg" title="Permalink to this headline">¶</a></h1>
<ul class="simple">
<li><p><b>Original repository</b>:   <a href="https://github.com/hci-unihd/plant-seg">  https://github.com/hci-unihd/plant-seg </a></p></li>
<li><p><b>License </b> : MIT License</p></li>
<li><p><b>Paper citation </b> : <i>Wolny A, Cerrone L, Vijayan A, Tofanelli R, Barro AV, Louveaux M, et al. Accurate and versatile 3D segmentation of plant tissues at cellular resolution. elife. 2020;9. doi:10.7554/eLife.57613 </i></p></li>
<li><p><b>Concept</b>: A residual 3D-UNet  is used for prediction of cell boundaries from a 3D image followed by using graph partitioning techniques such as GASP, Mutex and Multicut on predicted cell boundaries to get instance level segmentation.</p></li>
</ul>
   <div align="center">
<img src="../_static/ps_pipeline.png" alt="Plantseg pipeline" width="700" height="200"/>
 <figcaption>Schematic diagram of the Plantseg pipeline</figcaption>
</div>
<div class="section" id="installation">
<h2>Installation<a class="headerlink" href="#installation" title="Permalink to this headline">¶</a></h2>
<ol>
<li><p>Open a terminal and create a new environment as follows:</p>
<p><code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">create</span> <span class="pre">-n</span> <span class="pre">3dunet</span> <span class="pre">-c</span> <span class="pre">conda-forge</span> <span class="pre">-c</span> <span class="pre">awolny</span> <span class="pre">pytorch-3dunet</span></code></p>
</li>
</ol>
</div>
<div class="section" id="uses">
<h2>Uses<a class="headerlink" href="#uses" title="Permalink to this headline">¶</a></h2>
<p>The segmentation of an image using PlantSeg method requires a trained model. This model can be obtained in two different ways:</p>
<ul class="simple">
<li><p>Download one of the proposed <a href="https://doi.org/10.6084/m9.figshare.14433590.v1">  trained models </a></p></li>
<li><p>Train your own model using either your data or the proposed <a href="https://www.repository.cam.ac.uk/handle/1810/262530 "> training data  </a> (see <a class="reference internal" href="dataset.html"><span class="doc std std-doc">Datasets</span></a>).</p>
<ul>
<li><p><b>Type</b>: GUI application. To run the Plantseg pipeline, browse for the image, select the trained model (under Model Name), pre-processing and post processing parameters and click Run.</p></li>
</ul>
</li>
</ul>
<div align="center">
<img src="../_static/ps_sig.png" alt="Plantseg pipeline" width="1000" height="500"/>
<figcaption>Graphical user interface for running the Plantseg pipeline</figcaption>
</div>
<p>To install and start the GUI application run the commands:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">conda</span> <span class="n">create</span> <span class="o">-</span><span class="n">n</span> <span class="n">plant</span><span class="o">-</span><span class="n">seg</span> <span class="o">-</span><span class="n">c</span> <span class="n">lcerrone</span> <span class="o">-</span><span class="n">c</span> <span class="n">abailoni</span> <span class="o">-</span><span class="n">c</span> <span class="n">cpape</span> <span class="o">-</span><span class="n">c</span> <span class="n">awolny</span> <span class="o">-</span><span class="n">c</span> <span class="n">conda</span><span class="o">-</span><span class="n">forge</span> <span class="n">nifty</span><span class="o">=</span><span class="n">vplantseg1</span><span class="mf">.0.8</span> <span class="n">pytorch</span><span class="o">-</span><span class="mi">3</span><span class="n">dunet</span><span class="o">=</span><span class="mf">1.2.5</span> <span class="n">plantseg</span>

<span class="n">conda</span> <span class="n">activate</span> <span class="n">plant</span><span class="o">-</span><span class="n">seg</span>

<span class="n">plantseg</span> <span class="o">--</span><span class="n">gui</span>
</pre></div>
</div>
<ul>
<li><p><b>Pre-processing steps</b>: Rescaling images to XYZ resolution of training data, image interpolation, Gaussian or median filtering. Functions present within GUI</p></li>
<li><p><b>Dataset preparation</b>:  The training data comprises of .h5 files each of which contains 1 image and corresponding ground truth image.</p></li>
<li><p><b>Training environment</b>: Follow instructions under “Installation” for installing the Plantseg training environment.</p></li>
<li><p><b>Model training</b>: The training configurations are specified in the yaml file named “plantseg_train_config” as provided under docs/environments. The training may be invoked using the following command:</p>
<p><code class="docutils literal notranslate"><span class="pre">train3dunet</span> <span class="pre">--config</span> <span class="pre">&lt;PATH</span> <span class="pre">TO</span> <span class="pre">CONFIG</span> <span class="pre">YAML</span> <span class="pre">FILE&gt;</span></code>.</p>
</li>
</ul>
<p>The trained model (best_checkpoint.pytorch, last_checkpoint.pytorch) and the configuration file used for training may be uploaded to the Plantseg GUI using the “Add Custom Model” function in the GUI.</p>
<ul class="simple">
<li><p><b>Post-processing</b>:  Use either GASP, Mutex or Multicut functions on the GUI to get final segmentation.</p></li>
<li><p><b>Training data</b>: <a href="https://www.repository.cam.ac.uk/handle/1810/262530 "> https://www.repository.cam.ac.uk/handle/1810/262530  </a></p></li>
<li><p><b>Trained models</b>: <a href="https://doi.org/10.6084/m9.figshare.14433590.v1">  Link to trained model </a></p></li>
</ul>
</div>
<div class="section" id="results">
<h2>Results<a class="headerlink" href="#results" title="Permalink to this headline">¶</a></h2>
<p>You can find sample segmentation results and ground truth at this <a href="https://doi.org/10.6084/m9.figshare.14447079.v1">  link </a>.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Plantseg</a><ul>
<li><a class="reference internal" href="#installation">Installation</a></li>
<li><a class="reference internal" href="#uses">Uses</a></li>
<li><a class="reference internal" href="#results">Results</a></li>
</ul>
</li>
</ul>

  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/descriptions/plantseg.md.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">seg_compare 0.0.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Plantseg</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Anuradha Kar.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 3.2.1.
    </div>
  </body>
</html>